#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
/**
 *    author:  tourist
 *    created: 28.01.2018 16:04:02       
**/
#include <bits/stdc++.h>

using namespace std;

const int md = 998244353;

inline void add(int &a, int b) {
  a += b;
  if (a >= md) a -= md;
}

inline void sub(int &a, int b) {
  a -= b;
  if (a < 0) a += md;
}

inline int mul(int a, int b) {
  return (int) ((long long) a * b % md);
}

inline int power(int a, long long b) {
  int res = 1;
  while (b > 0) {
    if (b & 1) {
      res = mul(res, a);
    }
    a = mul(a, a);
    b >>= 1;
  }
  return res;
}

inline int inv(int a) {
  a %= md;
  if (a < 0) a += md;
  int b = md, u = 0, v = 1;
  while (a) {
    int t = b / a;
    b -= t * a; swap(a, b);
    u -= t * v; swap(u, v);
  }
  assert(b == 1);
  if (u < 0) u += md;
  return u;
}

int main() {
  int n, a, b;
  cin >> n >> a >> b;
  int p = mul(a, inv(b));
  vector<int> res(n);
  if (p != inv(2)) {
    int q = (1 - p + md) % md;
    vector<int> pow_q(n + 1), pow_p(n + 1);
    pow_q[0] = pow_p[0] = 1;
    for (int i = 1; i <= n; i++) {
      pow_q[i] = mul(pow_q[i - 1], q);
      pow_p[i] = mul(pow_p[i - 1], p);
    }
    int ans = 1;
    for (int i = 1; i <= n - 1; i++) {
      ans = mul(ans, (pow_q[n + 1 - i] - pow_p[n + 1 - i] + md) % md);
      ans = mul(ans, inv((pow_q[i] - pow_p[i] + md) % md));
      res[i] = ans;
    }
  } else {
    vector<int> pow_p(n + 1);
    pow_p[0] = 1;
    for (int i = 1; i <= n; i++) {
      pow_p[i] = mul(pow_p[i - 1], p);
    }
    int c = 1;
    for (int i = 1; i <= n - 1; i++) {
      c = mul(c, mul(n + 1 - i, inv(i)));
      // i * (n - i) - (i - 1) * (n - i + 1) = n - 2 * i + 1
      int diff = n - 2 * i + 1;
      if (diff >= 0) {
        c = mul(c, pow_p[diff]);
      } else {
        c = mul(c, inv(pow_p[-diff]));
      }
      res[i] = c;
    }
  }
  int g = 1, total = 0;
  for (int i = 1; i <= n - 1; i++) {
    add(total, mul(res[i], g));
    g = mul(g, g);
    add(g, 2);
  }
  printf("%d\n", total);
  return 0;
}
