#include <bits/stdc++.h>

using namespace std;

struct generator {
  int seed;
  int a;
  int b;
  int md;

  generator(int _md) : md(_md) {
    cin >> seed >> a >> b;
  }

  int yield() {
    int old = seed;
    seed = (int) ((a * 1LL * seed + b) % md);
    return old;
  }

  vector<int> pre;
  vector<int> period;

  void analyze() {
    map<int,int> was;
    vector<int> values;
    while (true) {
      int cur = yield();
      if (was.find(cur) != was.end()) {
        int pos = was[cur];
        for (int i = 0; i < pos; i++) {
          pre.push_back(values[i]);
        }
        for (int i = pos; i < (int) values.size(); i++) {
          period.push_back(values[i]);
        }
        break;
      }
      was[cur] = (int) values.size();
      values.push_back(cur);
    }
  }

  void advance(int t) {
    for (int i = 0; i < t; i++) {
      pre.push_back(period[i % (int) period.size()]);
    }
    rotate(period.begin(), period.begin() + (t % (int) period.size()), period.end());
  }
};

struct my_set {
  long long res;
  set<int> s;
  int sz;

  my_set(int c) {
    s.insert(-1);
    s.insert(c);
    res = profit(-1, c);
    sz = 0;
  }

  long long profit(int from, int to) {
    int x = to - from;
    return (long long) x * (x - 1) / 2;
  }

  void insert(int x) {
    assert(s.find(x) == s.end());
    auto it = s.lower_bound(x);
    int nxt = *it;
    int prv = *(--it);
    res = res - profit(prv, nxt) + profit(x, nxt) + profit(prv, x);
    s.insert(x);
    sz++;
  }

  void erase(int x) {
    auto it = s.find(x);
    assert(it != s.end());
    ++it;
    int nxt = *it;
    --it;
    --it;
    int prv = *it;
    ++it;
    res = res - profit(x, nxt) - profit(prv, x) + profit(prv, nxt);
    s.erase(it);
    sz--;
  }
};

int main() {
  int r, c;
  long long k;
  cin >> r >> c >> k;
  generator gx(r);
  generator gy(c);
  gx.analyze();
  gy.analyze();
  if (gx.pre.size() < gy.pre.size()) {
    gx.advance((int) (gy.pre.size() - gx.pre.size()));
  }
  if (gx.pre.size() > gy.pre.size()) {
    gy.advance((int) (gx.pre.size() - gy.pre.size()));
  }
  assert(gx.pre.size() == gy.pre.size());
  vector< vector<int> > additional(r);
  for (int i = 0; i < (int) gx.pre.size(); i++) {
    if (i < k) {
      additional[gx.pre[i]].push_back(gy.pre[i]);
    }
  }
  k = max(0LL, k - (int) gx.pre.size());
  int nx = (int) gx.period.size();
  int ny = (int) gy.period.size();
  vector< vector< pair<int,int> > > at(c);
  for (int i = 0; i < nx; i++) {
    int cnt = (int) ((k - i + nx - 1) / nx);
    at[i % ny].emplace_back(cnt, gx.period[i]);
  }
  int g = __gcd(nx, ny);
  vector<bool> used(r, false);
  long long ans = 0;
  for (int rm = 0; rm < g; rm++) {
    my_set ms(c);
    int i = rm;
    while (true) {
      sort(at[i].begin(), at[i].end());
      for (auto &p : at[i]) {
        int cnt = p.first;
        int x = p.second;
        while (ms.sz < cnt) {
          int pos = (int) ((i + (long long) ms.sz * nx) % ny);
          ms.insert(gy.period[pos]);
        }
        for (int y : additional[x]) {
          ms.insert(y);
        }
        ans += ms.res;
        for (int y : additional[x]) {
          ms.erase(y);
        }
        assert(!used[x]);
        used[x] = true;
      }
      if (ms.sz > 0) {
        ms.erase(gy.period[i]);
      }
      i = (i + nx) % ny;
      if (i == rm) {
        break;
      }
    }
  }
  for (int x = 0; x < r; x++) {
    if (used[x]) {
      continue;
    }
    my_set ms(c);
    for (int y : additional[x]) {
      ms.insert(y);
    }
    ans += ms.res;
    for (int y : additional[x]) {
      ms.erase(y);
    }
  }
  cout << ans << endl;
  return 0;
}
