#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
/**
 *    author:  tourist
 *    created: 28.01.2018 16:37:22       
**/
#include <bits/stdc++.h>

using namespace std;

struct line {
  long long a;
  long long b;
  long long c;

  line(long long _a, long long _b, long long _c) : a(_a), b(_b), c(_c) { }
  
  long long get_y(long long x) {
    assert((-a * x - c) % b == 0);
    return (-a * x - c) / b;
  }
};

int main() {
  int n;
  scanf("%d", &n);
  vector<int> l(n), r(n);
  for (int i = 0; i < n; i++) {
    scanf("%d %d", &l[i], &r[i]);
    // l[i] <= a[0] + d * i <= r[i]
    // let (x, y) = (d, a[0])
    // l[i] <= x * i + y <= r[i]
  }
  const int inf = (int) 1.01e9;
  vector< pair<line, long long> > hulls[2];
  for (int it = 0; it < 2; it++) {
    vector< pair<line, long long> > &hull = hulls[it];
    for (int aux = 0; aux < n; aux++) {
      int i = (it == 0 ? n - 1 - aux : aux);
      line cur(i, 1, it == 0 ? -l[i] : -r[i]);
      if (hull.empty()) {
        hull.emplace_back(cur, -inf);
        continue;
      }
      while (!hull.empty()) {
        long long x = hull.back().second;
        long long me = cur.get_y(x);
        long long him = hull.back().first.get_y(x);
        if ((it == 0 && me < him) || (it == 1 && me > him)) {
          break;
        }
        hull.pop_back();
      }
      long long low = hull.back().second;
      long long high = inf;
      while (low < high) {
        long long x = (low + high) >> 1;
        long long me = cur.get_y(x);
        long long him = hull.back().first.get_y(x);
        if ((it == 0 && me < him) || (it == 1 && me > him)) {
          low = x + 1;
        } else {
          high = x;
        }
      }
      hull.emplace_back(cur, low);
    }
  }
  long long ans = 0;
  vector<int> id(2, 0);
  while (id[0] < (int) hulls[0].size() && id[1] < (int) hulls[1].size()) {
    vector<long long> nxt(2);
    for (int i = 0; i < 2; i++) {
      nxt[i] = (id[i] + 1 < (int) hulls[i].size() ? hulls[i][id[i] + 1].second : inf);
    }
    long long from = max(hulls[0][id[0]].second, hulls[1][id[1]].second);
    long long to = min(nxt[0], nxt[1]) - 1;
    assert(from <= to);
    long long d1 = hulls[1][id[1]].first.get_y(from) - hulls[0][id[0]].first.get_y(from) + 1;
    long long d2 = hulls[1][id[1]].first.get_y(to) - hulls[0][id[0]].first.get_y(to) + 1;
    long long cnt = to - from + 1;
    if (d1 > d2) {
      swap(d1, d2);
    }
    if (d2 > 0) {
      if (d1 <= 0) {
        assert((d2 - d1) % (cnt - 1) == 0);
        long long step = (d2 - d1) / (cnt - 1);
        long long delta = (-d1) / step + 1;
        cnt -= delta;
        d1 += delta * step;
      }
      assert(cnt > 0 && d1 > 0 && d2 > 0);
      ans += (d1 + d2) * cnt / 2;
    }
    id[0] += (nxt[0] <= nxt[1]);
    id[1] += (nxt[1] <= nxt[0]);
  }
  cout << ans << endl;
  return 0;
}
