/**
 *    author:  tourist
 *    created: 01.02.2018 16:50:02       
**/
#undef _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

inline bool have_common(pair<int,int> p, pair<int,int> q) {
  return (p.first == q.first || p.first == q.second || p.second == q.first || p.second == q.second);
}

int main() {
  int n, m;
  scanf("%d %d", &n, &m);
  vector< vector<int> > g(n);
  for (int i = 0; i < m; i++) {
    int foo, bar;
    scanf("%d %d", &foo, &bar);
    foo--; bar--;
    g[foo].push_back(bar);
    g[bar].push_back(foo);
  }
  map< vector<int>,int > mp;
  vector<int> link(n, -1);
  for (int i = 0; i < n; i++) {
    vector<int> here = g[i];
    here.push_back(i);
    sort(here.begin(), here.end());
    if (mp.find(here) != mp.end()) {
      link[i] = mp[here];
    } else {
      mp[here] = i;
    }
  }
  vector< pair<int,int> > res(n, make_pair(-1, -1));
  int cnt = 0;
  map<int,int> occ;
  set< pair<int,int> > used;
  vector<bool> was(n, false);
  for (int i = 0; i < n; i++) {
    if (link[i] != -1) {
      was[i] = true;
    }
  }
  for (int start = 0; start < n; start++) {
    if (was[start]) {
      continue;
    }
    vector<int> que;
    vector< vector<int> > nei;
    que.push_back(start);
    was[start] = true;
    auto fix = [&](int v) {
      occ[res[v].first]++;
      occ[res[v].second]++;
      used.emplace(res[v].first, res[v].second);
      used.emplace(res[v].second, res[v].first);
    };
    int used_colors = 0;
    for (int i = 0; i < (int) que.size(); i++) {
      int v = que[i];
      for (int j : g[v]) {
        if (!was[j]) {
          que.push_back(j);
          was[j] = true;
        }
      }
      nei.push_back(vector<int>());
      map<int,int> my_occ;
      for (int j : g[v]) {
        if (res[j] != make_pair(-1, -1)) {
          nei[i].push_back(j);
          my_occ[res[j].first]++;
          my_occ[res[j].second]++;
        }
      }
      if (used_colors <= 4) {
        set< pair<int,int> > used_in_dfs;
        function<bool(int)> dfs = [&](int id){
          if (id == i + 1) {
            return true;
          }
          for (int x = 0; x < used_colors; x++) {
            for (int y = x + 1; y < used_colors; y++) {
              if (id == 0 && (x != 0 || y != 1)) {
                continue;
              }
              if (id == 1 && (x != 0 || y != 2)) {
                continue;
              }
              if (used_in_dfs.find(make_pair(x, y)) != used_in_dfs.end()) {
                continue;
              }
              res[que[id]] = make_pair(cnt + x, cnt + y);
              bool ok = true;
              for (int j = 0; j < id; j++) {
                bool is_nei = (find(nei[id].begin(), nei[id].end(), que[j]) != nei[id].end());
                bool really_nei = have_common(res[que[id]], res[que[j]]);
                if (is_nei != really_nei) {
                  ok = false;
                  break;
                }
              }
              if (ok) {
                used_in_dfs.emplace(x, y);
                if (dfs(id + 1)) {
                  return true;
                }
                used_in_dfs.erase(make_pair(x, y));
              }
            }
          }
          return false;
        };
        for (used_colors = 2; used_colors <= 8; used_colors++) {
          if (dfs(0)) {
            break;
          }
        }
        if (used_colors > 8) {
          puts("No");
          return 0;
        }
        if (used_colors > 4) {
          cnt += used_colors;
          for (int j = 0; j <= i; j++) {
            fix(que[j]);
          }
        }
        continue;
      }
      set<int> can_be_used;
      for (auto &p : my_occ) {
        if (p.second == occ[p.first]) {
          can_be_used.insert(p.first);
        }
      }
      int best_cover_size = 3;
      pair<int,int> best_pair = make_pair(-1, -1);
      for (int att = 0; att < 2; att++) {
        int my_first = (att == 0 ? res[nei[i][0]].first : res[nei[i][0]].second);
        if (can_be_used.find(my_first) == can_be_used.end()) {
          continue;
        }
        map<int, int> freq;
        int uncovered = 0;
        for (int u : nei[i]) {
          if (res[u].first == my_first || res[u].second == my_first) {
            continue;
          }
          uncovered++;
          freq[res[u].first]++;
          freq[res[u].second]++;
        }
        int cover_size = 1;
        int my_second = -1;
        if (uncovered != 0) {
          for (auto &p : freq) {
            if (can_be_used.find(p.first) == can_be_used.end()) {
              continue;
            }
            if (used.find(make_pair(my_first, p.first)) != used.end()) {
              continue;
            }
            if (p.second == uncovered) {
              my_second = p.first;
              break;
            }
          }
          if (my_second != -1) {
            cover_size = 2;
          } else {
            cover_size = 3;
          }
        }
        if (cover_size < best_cover_size) {
          best_cover_size = cover_size;
          best_pair = make_pair(my_first, my_second);
        }
      }
      if (best_cover_size == 3) {
        puts("No");
        return 0;
      }
      res[v] = best_pair;
      if (res[v].second == -1) {
        res[v].second = cnt++;
      }
      fix(v);
    }
    if (used_colors <= 4) {
      cnt += used_colors;
      for (int j = 0; j < (int) que.size(); j++) {
        fix(que[j]);
      }
    }
  }
  for (int i = 0; i < n; i++) {
    if (link[i] != -1) {
      res[i] = res[link[i]];
    }
  }
  puts("Yes");
  for (int i = 0; i < n; i++) {
    printf("%d %d\n", res[i].first, res[i].second);
  }
  return 0;
}
