import java.util.*;
import java.io.*;
import java.math.*;

public class Main {

	final long MOD = 998244353;

	void solve() {
		long n = in.nextLong();
		List<Integer> exponents = factorize(n);
		n = exponents.size();
		int divs = 1;
		for (int i : exponents) {
			divs *= i + 1;
		}
		long[] pow2 = new long[divs + 1];
		pow2[0] = 1;
		for (int i = 1; i <= divs; i++) {
			pow2[i] = pow2[i - 1] * 2 % MOD;
		}
		long result = 0;
		for (int mask1 = 0; mask1 < 1 << n; mask1++) {
			for (int mask2 = mask1; ; mask2 = (mask2 - 1) & mask1) {
				int size = 1;
				int mul = 1;
				for (int i = 0; i < n; i++) {
					int cur = exponents.get(i);
					int bit1 = (mask1 >> i) & 1, bit2 = (mask2 >> i) & 1;
					cur -= bit1 + bit2;
					if ((bit1 ^ bit2) == 1) {
						mul *= -2;
					}
					size *= (cur + 1);
					if (size == 0) {
						break;
					}
				}
				result += mul * (pow2[size] - 1) % MOD;
				if (mask2 == 0) {
					break;
				}
			}
		}
		out.println((result % MOD + MOD) % MOD);
	}

	List<Integer> factorize(long n) {
		List<Integer> result = new ArrayList<>();
		for (int i = 2; 1L * i * i * i <= n; i++) {
			if (n % i == 0) {
				int exp = 0;
				while (n % i == 0) {
					exp++;
					n /= i;
				}
				result.add(exp);
			}
		}
		if (n > 1) {
			if (BigInteger.valueOf(n).isProbablePrime(1000)) {
				result.add(1);
			} else {
				long x = (long) (Math.sqrt(n) + 0.5);
				if (x * x == n) {
					result.add(2);
				} else {
					result.add(1);
					result.add(1);
				}
			}
		}
		return result;
	}

	FastScanner in;
	PrintWriter out;

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}
